function varargout = line_extract_interpolate_v4b(data, kk, reslim)

    % newline = line_extract_interpolate_v4b(database, [kI, kR])
    %  -- or --
    % [newline, distance] = line_extract_interpolate_v4b(database, [kI, kR])
    %  -- or --
    % [newline, distance, npoints] = line_extract_interpolate_v4b(database, [kI, kR])

    % per trovare (kI, kR) calcolo distanza dai punti

    % otional third argument
    if nargin >= 3
        % pre-filter data keeping only good results
        filter17 = data(:,17) <= reslim(1);
        filter18 = data(:,18) <= reslim(2);
        data = data(logical(filter17.*filter18),:);
    end    

    % NOTE: pnorm not available in all systems... redo with norm
    %pp = vecnorm(data(:,1:2)-kk, 2, 2);
    pp = (data(:,1)-kk(1)).^2+(data(:,2)-kk(2)).^2;

    [~, indx] = sort(pp);

    if pp(indx(1)) < 1e-9
        existing = true;
        thedist = pp(indx(2));
    else
        existing = false;
        thedist = pp(indx(1));
    end

    % quelli pi vicini sono:
    flags = abs(pp - thedist) < 1e-9;
    restricted = data(flags,:);
    
    switch size(restricted,1)
        case 1
            % nothing to do...
            newline = restricted(1:8);
        case 2
            % con due faccio la media secca (0.5 e 0.5)
            newline = 0.5*restricted(1,1:8)+0.5*restricted(2,1:8);
        case 3
            % devo averne due allineati, 0.4 e 0.4 per loro, 0.2 l'altro
            kkk = [1/3, 1/3, 1/3];
            if restricted(1,1)==restricted(2,1); kkk=[.4, .4, .2]; end
            if restricted(1,1)==restricted(3,1); kkk=[.2, .2, .4]; end
            if restricted(2,1)==restricted(3,1); kkk=[.2, .4, .4]; end
            if restricted(1,2)==restricted(2,2); kkk=[.4, .4, .2]; end
            if restricted(1,2)==restricted(3,2); kkk=[.2, .2, .4]; end
            if restricted(2,2)==restricted(3,2); kkk=[.2, .4, .4]; end
            newline = kkk(1)*restricted(1,1:8)+kkk(2)*restricted(2,1:8)+kkk(3)*restricted(3,1:8);
        case 4
            % con due faccio la media secca (0.25 ciascuno)
            newline = 0.25*restricted(1,1:8)+0.25*restricted(2,1:8)+0.25*restricted(3,1:8)+0.25*restricted(4,1:8);
        otherwise
            error('???');
    end
    
    newline(1:2) = kk;
    newline(9:16) = zeros(1,8);
    newline(17:18) = [1., 1.];
    newline(19:32) = -ones(1,14);

    switch nargout
        case {0, 1}
            varargout = {newline};
        case 2
            varargout = {newline, sqrt(thedist)};
        case 3
            % 
            varargout = {newline, sqrt(thedist), size(restricted,1)};
        otherwise
            warning('Wrong output argument number, no output set.')
    end

end