function varargout = line_extract_nearest_v4b(data, kk, reslim)
% find nearest line - if not existing, update kI, kR and residuals
% additional third arguments is [res5, res4]: minimum residual to be looked
% for

    % newline = line_extract_nearest_v4a(database, [kI, kR])
    %  -- or --
    % [newline, distance] = line_extract_nearest_v4a(database, [kI, kR])
    %  -- or --
    % [newline, distance, npoints] = line_extract_nearest_v4a(database, [kI, kR])

    % per trovare (kI, kR) calcolo distanza dai punti

    % otional third argument
    if nargin >= 3
        % pre-filter data keeping only good results
        filter17 = data(:,17) <= reslim(1);
        filter18 = data(:,18) <= reslim(2);
        data = data(logical(filter17.*filter18),:);
    end 
    
    if size(data,1)>0
        
    
    % NOTE: pnorm not available in all systems... redo with norm
    %pp = vecnorm(data(:,1:2)-kk, 2, 2);
    data = data(randperm(size(data,1)),:); % random shuffle
    pp = (data(:,1)-kk(1)).^2+(data(:,2)-kk(2)).^2;


    [~, indx] = sort(pp);
    newline = data(indx(1),:);

    if norm(newline(1:2)-kk) > 1e-4 % 0 with tolerance
        % clear residuals and update kI, kR if not existing
        newline(1:2) = kk;
        newline(9:16) = zeros(1,8);
        newline(17:18) = [1., 1.];
        newline(19:32) = -ones(1,14);
    end
    
    dist = sqrt(pp(indx(1)));
    
    else
        dist = inf;
        newline = zeros(1,32);
    end
    
    switch nargout
        case {0, 1}
            varargout = {newline};
        case 2
            varargout = {newline, dist};
        case 3
            % 
            varargout = {newline, dist, sum(abs(pp-pp(indx(1)))<1e-6)};
        otherwise
            warning('Wrong output argument number, no output set.')
    end

    
end